import { world, system } from "@minecraft/server";

function durabilityOnChanged(item, player, isHitEntity = false) {
    let level = item.getComponent("minecraft:enchantable")?.getEnchantment("unbreaking")?.level;

    function durability() {
        let durability = item.getComponent("minecraft:durability");

        const t = Math.floor(Math.random() * 100);

        if (t < durability.getDamageChance()) {
            if (!isHitEntity) durability.damage += 1;
            if (durability.damage >= durability.maxDurability) {
                player.playSound("random.break");
                if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', undefined)
            } else {
                if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', item)
            }
        } else {
            if (!isHitEntity) return;
            durability.damage -= 1;
            if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', item);
        }
    }

    const t = Math.floor(Math.random() * 10)
    if (level === 1 && t > 8) return;
    else if (level === 2 && t > 6) return;
    else if (level === 3 && t > 4) return;
    else durability();
}

world.beforeEvents.worldInitialize.subscribe(initEvent => { initEvent.itemComponentRegistry.registerCustomComponent('wb_flute_of_friendship:trigger', {
  onUse: e => { e.source.runCommand("function village_hero"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_wandering_bag1:trigger', {
  onUse: e => { e.source.runCommand("function hammer_from_farlands"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_wandering_bag2:trigger', {
  onUse: e => { e.source.runCommand("function flute_of_friendship"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_hammer_from_farlands:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function knockback"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_wandering_bag3:trigger', {
  onUse: e => { e.source.runCommand("function spice_from_elsewhere"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_wandering_bag4:trigger', {
  onUse: e => { e.source.runCommand("function bucket_from_unknown_bag"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_bucket_from_unknown:trigger', {
  onUse: e => { e.source.runCommand("function bucket_from_unknown"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_potion_of_spice:trigger', {
  onConsume: e => {
  e.source.addEffect("minecraft:hunger", 1800, {amplifier: 4});
e.source.addEffect("minecraft:resistance", 1800, {amplifier: 6});
  
},

  
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_horn_of_raiding:trigger', {
  onUse: e => { e.source.runCommand("function horn_call"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_pillager_bag2:trigger', {
  onUse: e => { e.source.runCommand("function stone_of_renegade"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_pillager_bag1:trigger', {
  onUse: e => { e.source.runCommand("function dagger_of_traitor"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_dagger_of_traitor:trigger', {
  
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_pillager_bag3:trigger', {
  onUse: e => { e.source.runCommand("function herb_of_rescue"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_pillager_bag4:trigger', {
  onUse: e => { e.source.runCommand("function horn_of_raiding"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_stone_of_renegade:trigger', {
  onUse: e => { e.source.runCommand("function strength_stone"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_chime_of_bewail:trigger', {
  onUse: e => { e.source.runCommand("function slow"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_flask_of_adaptation:trigger', {
  onUse: e => { e.source.runCommand("function flask"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_potion_of_blessing:trigger', {
  onConsume: e => {
  e.source.removeEffect("minecraft:poison");
e.source.removeEffect("minecraft:wither");
e.source.removeEffect("minecraft:fatal_poison");
e.source.removeEffect("minecraft:instant_damage");
e.source.removeEffect("minecraft:blindness");
e.source.removeEffect("minecraft:nausea");
e.source.removeEffect("minecraft:weakness");
e.source.removeEffect("minecraft:hunger");
e.source.removeEffect("minecraft:mining_fatigue");
e.source.removeEffect("minecraft:slowness");
  
},

  
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_witch_bag1:trigger', {
  onUse: e => { e.source.runCommand("function forbidden_spell"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_witch_bag3:trigger', {
  onUse: e => { e.source.runCommand("function swamp_essence"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_forbidden_spell:trigger', {
  onUse: e => { e.source.runCommand("function slime"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_witch_bag2:trigger', {
  onUse: e => { e.source.runCommand("function flask_of_adaptation"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_witch_bag4:trigger', {
  onUse: e => { e.source.runCommand("function chime_of_bewail"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_drums_of_underworld:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function knockback"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_whip_of_dominance:trigger', {
  onUse: e => { e.source.runCommand("function piglin_dominance"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_piglin_bag2:trigger', {
  onUse: e => { e.source.runCommand("function whip_of_dominance"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_piglin_bag1:trigger', {
  onUse: e => { e.source.runCommand("function drums"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_piglin_bag3:trigger', {
  onUse: e => { e.source.runCommand("function chalice_of_swine"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_chalice_of_swine:trigger', {
  onConsume: e => {
  e.source.addEffect("minecraft:fire_resistance", 1200, {amplifier: 1});
e.source.removeEffect("minecraft:wither");
  
},

  
});

initEvent.itemComponentRegistry.registerCustomComponent('wb_piglin_bag4:trigger', {
  onUse: e => { e.source.runCommand("function withered_bonemeal"); },
});
 });
